module SimpleCrop

using Persefone:
    AbstractCropType,
    AbstractCropState,
    SimulationModel,
    initfields_fill_with!
import Persefone:
    Persefone,
    stepagent!,
    croptype,
    cropname,
    cropheight

struct CropType <: AbstractCropType
    name::String
end

cropname(ct::CropType) = ct.name

mutable struct CropState <: AbstractCropState
    croptype::CropType
    cropheight::Float64
end

croptype(cs::CropState) = cs.croptype
cropname(cs::CropState) = cropname(croptype(cs))
cropheight(cs::CropState) = cs.height

const FarmPlot = Persefone.FarmPlot{CropState}

"""
    stepagent!(farmplot, model)

Update a farm plot by one day.
"""
function stepagent!(farmplot::FarmPlot, model::SimulationModel)
    # TODO: do something simple
end

"""
    initfields!(model)

Initialise the model with its farm plots.
"""
function initfields!(model::SimulationModel)
    initfields_fill_with!(model) do model, x, y
        FarmPlot(length(model.farmplots) + 1, [(x,y)], CropState(CropType("nothing"), 0.0))
    end
end

end # module SimpleCrop
